#!/usr/bin/env python
# -*- coding: utf-8 -*-

# author: Pocholo
# date: 9/27/21

# Inspire by Conbagui Artwork found here:https://www.deviantart.com/conbagui/art/Happy-New-Year-2020-City-825237305

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user plugins folder

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY# without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>. 


from gimpfu import *
import gettext
import os, sys,time 

gettext.install("gimp20", gimp.locale_directory, unicode=True)
def create_a_happy_new_year_design(customtext, customtext2, fontname, fontColor, color, firewColor1, firewColor2):
	
    #Set gimp to default
    pdb.gimp_context_set_defaults()
		
    #Variables
    width = 2000
    height = 1330
		
    #Create the background
    img = pdb.gimp_image_new(width, height, RGB)
    backLayer = pdb.gimp_layer_new(img, width, height, RGB_IMAGE, "Background", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(backLayer)
    pdb.gimp_image_add_layer(img, backLayer, 0)
    pdb.gimp_context_set_foreground((15, 28, 45))
    pdb.gimp_edit_bucket_fill(backLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_display_new(img)

    #Stars
    starsLayer = pdb.gimp_layer_new(img, width, height, RGB, "Stars", 100, LAYER_MODE_SCREEN)
    pdb.gimp_layer_add_alpha(starsLayer)
    pdb.gimp_image_add_layer(img, starsLayer, 0)	
    pdb.gimp_context_set_foreground((0, 0, 0))
    pdb.gimp_drawable_fill(starsLayer, FILL_FOREGROUND)
    pdb.gimp_layer_scale(starsLayer, 2000, 808, FALSE)
    pdb.plug_in_hsv_noise(img, starsLayer, 8, 0, 0, 255)
    pdb.gimp_brightness_contrast(starsLayer, -80, 50)
    pdb.plug_in_gauss(img, starsLayer, 0.50, 0.50, 1)
    pdb.gimp_context_set_foreground(color)
    pdb.plug_in_sparkle(img, starsLayer, 
                                  0.001, #Luminosity threshold
	                               0.50, #Flare intensity 
								     20, #Spike length
								      4, #spike points
								     15, #Spike angle
								   1.00, #Spike density
								      0, #Transparency
								      0, #Random hue
								      0, #Random saturation
								  FALSE, #Preserve luminosity
								  FALSE, #Inverse
								  FALSE, #Add border
								      1) #Color of sparkles - foreground
    pdb.gimp_layer_resize_to_image_size(starsLayer)

    #Create the buildings
    buildLayer = pdb.gimp_layer_new(img, width, height, RGB_IMAGE, "Buildings", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(buildLayer)
    pdb.gimp_image_add_layer(img, buildLayer, 0)
    pdb.gimp_drawable_fill(buildLayer, FILL_TRANSPARENT)
    pdb.gimp_brushes_set_brush("2. Hardness 100")
    pdb.gimp_context_set_brush_size(7)
    pdb.gimp_context_set_brush_default_hardness()
    pdb.gimp_context_set_brush_spacing(0.01)
    pdb.gimp_context_set_brush_force(0.50)
    pdb.gimp_context_set_foreground(color)

    #Left ground
    pdb.gimp_paintbrush_default(buildLayer, 4, [0, 810, 
                                                  2000,
												  810])
	
    #Building 1
    pdb.gimp_paintbrush_default(buildLayer, 4, [414, 810,
                                                     414,
												     490])
    pdb.gimp_paintbrush_default(buildLayer, 4, [414, 490, 
                                                     558, 
												     490,])
    pdb.gimp_paintbrush_default(buildLayer, 4, [558, 490,
	                                                 558,
													 810])												 
    #Building 1 antenna 
    pdb.gimp_paintbrush_default(buildLayer, 4, [486, 490,
	                                                 486,
													 387])	
    #Building 1 windows
    pdb.gimp_context_set_foreground(color)
    pdb.gimp_image_select_rectangle(img, 2, 500, 536, 40, 30)	
    pdb.gimp_context_set_antialias(TRUE)
    pdb.gimp_context_set_line_cap_style(CAP_ROUND)
    pdb.gimp_context_set_line_join_style(JOIN_MITER)
    pdb.gimp_context_set_line_miter_limit(10)
    pdb.gimp_context_set_line_width(6)
    pdb.gimp_context_set_stroke_method(STROKE_LINE)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 436, 536, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 500, 611, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 500, 683, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 436, 737, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)

		
    #Building 2
    pdb.gimp_paintbrush_default(buildLayer, 4, [558, 597,
	                                                 633,
													 559])	
    pdb.gimp_paintbrush_default(buildLayer, 4, [633, 559,
	                                                 706,
													 597])
    pdb.gimp_paintbrush_default(buildLayer, 4, [706, 597,
	                                                 706,
													 810])	
    #Building 2 windows
    pdb.gimp_image_select_rectangle(img, 2, 582, 611, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 650, 611, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 650, 668, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 650, 728, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 582, 731, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
            
    #Building 3
    pdb.gimp_paintbrush_default(buildLayer, 4, [706, 688,
	                                                 852,
													 688])	
    #Building 3 windows
    pdb.gimp_image_select_rectangle(img, 2, 726, 705, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 790, 705, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 760, 760, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
            
    #Building 4
    pdb.gimp_paintbrush_default(buildLayer, 4, [852, 810,
	                                                 852,
													 500])
    pdb.gimp_paintbrush_default(buildLayer, 4, [852, 500,
	                                                 999,
													500])
    #Building 4 antenna 
    pdb.gimp_paintbrush_default(buildLayer, 4, [928, 500,
	                                                 928,
													 400])
    #Building 4 windows
    pdb.gimp_image_select_rectangle(img, 2, 940, 537, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 879, 537, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 879, 595, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 940, 700, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 879, 700, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 940, 754, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)

    #Building 5
    pdb.gimp_paintbrush_default(buildLayer, 4, [999, 810,
	                                                 999,
													397])
    pdb.gimp_paintbrush_default(buildLayer, 4, [999, 397,
	                                                1071,
													360])	
    pdb.gimp_paintbrush_default(buildLayer, 4, [1071, 360,
	                                                 1146,
													 397])	
    pdb.gimp_paintbrush_default(buildLayer, 4, [1146, 397,
	                                                 1146,
													 810])
    #Building 5 windows
    pdb.gimp_image_select_rectangle(img, 2, 1024, 442, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1085, 442, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1085, 505, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1085, 571, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1085, 636, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1085, 700, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1024, 508, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1024, 702, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1024, 754, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
	
    #Building 6
    pdb.gimp_paintbrush_default(buildLayer, 4, [1146, 594,
	                                                 1218,
													 560])	
    pdb.gimp_paintbrush_default(buildLayer, 4, [1218, 560,
	                                                 1290,
													 594])	
    pdb.gimp_paintbrush_default(buildLayer, 4, [1290, 594,
	                                                 1290,
													 810])
    #Building 6 windows
    pdb.gimp_image_select_rectangle(img, 2, 1170, 617, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1170, 750, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1232, 617, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1232, 682, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1232, 750, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)

    #Building 7
    pdb.gimp_paintbrush_default(buildLayer, 4, [1290, 672,
	                                                 1437,
													 672])
    #Building 7 windows
    pdb.gimp_image_select_rectangle(img, 2, 1316, 700, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1316, 760, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1376, 700, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)

    #Building 8
    pdb.gimp_paintbrush_default(buildLayer, 4, [1437, 810,
	                                                 1437,
													 500])
    pdb.gimp_paintbrush_default(buildLayer, 4, [1437, 500,
	                                                 1587,
													 500])	
    pdb.gimp_paintbrush_default(buildLayer, 4, [1587, 500,
	                                                 1587,
													 810])
    #Building 8antenna 
    pdb.gimp_paintbrush_default(buildLayer, 4, [1512, 500,
	                                                 1512,
													 400])
    #Building 8 windows
    pdb.gimp_image_select_rectangle(img, 2, 1462, 537, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1523, 537, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1462, 600, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1523, 650, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1523, 710, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_rectangle(img, 2, 1462, 760, 40, 30)
    pdb.gimp_drawable_edit_stroke_selection(buildLayer)
    pdb.gimp_selection_none(img)
	
    #Trees 1 and 2
    treeLayer = pdb.gimp_layer_new(img, width, height, RGB_IMAGE, "Trees", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(treeLayer)
    pdb.gimp_image_add_layer(img, treeLayer, 0)
    pdb.gimp_drawable_fill(treeLayer, FILL_TRANSPARENT)	
    pdb.gimp_image_select_polygon(img, CHANNEL_OP_REPLACE, 8, [102, 710, 43, 772, 164, 772, 102, 710])
    pdb.gimp_drawable_edit_stroke_selection(treeLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_polygon(img, CHANNEL_OP_REPLACE, 8, [102, 670, 48, 732, 156, 732, 102, 670])
    pdb.gimp_drawable_edit_clear(treeLayer)
    pdb.gimp_drawable_edit_stroke_selection(treeLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_image_select_polygon(img, CHANNEL_OP_REPLACE, 8, [102, 647, 58, 697, 147, 697, 102, 647])
    pdb.gimp_drawable_edit_clear(treeLayer)
    pdb.gimp_drawable_edit_stroke_selection(treeLayer)
    pdb.gimp_selection_none(img) 
    pdb.gimp_paintbrush_default(treeLayer, 4, [102, 772, 102, 809])
    #Trees 2
    non_empty = pdb.gimp_edit_copy(treeLayer)
    treeLayer2 = pdb.gimp_layer_new(img,  width, height, RGB_IMAGE, "Trees 2", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(treeLayer2)
    pdb.gimp_image_add_layer(img, treeLayer2, 0)
    pdb.gimp_drawable_fill(treeLayer2, FILL_TRANSPARENT)	
    treeLayer2 = pdb.gimp_edit_paste(treeLayer2, FALSE)
    pdb.gimp_floating_sel_anchor(treeLayer2)
    treeLayer2 = pdb.gimp_image_get_layer_by_name(img, "Trees 2")	
    treeLayer2 = pdb.gimp_item_transform_translate(treeLayer2, 180, 0)	
    treeLayer = pdb.gimp_image_merge_down(img, treeLayer2, CLIP_TO_IMAGE)

    #Trees 3 and 4
    non_empty = pdb.gimp_edit_copy(treeLayer)
    treeLayer3_4 = pdb.gimp_layer_new(img,  width, height, RGB_IMAGE, "Trees 3 and 4", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(treeLayer3_4)
    pdb.gimp_image_add_layer(img, treeLayer3_4, 0)
    pdb.gimp_drawable_fill(treeLayer3_4, FILL_TRANSPARENT)	
    treeLayer3_4 = pdb.gimp_edit_paste(treeLayer3_4, FALSE)
    pdb.gimp_floating_sel_anchor(treeLayer3_4)
    treeLayer3_4 = pdb.gimp_image_get_layer_by_name(img, "Trees 3 and 4")	
    treeLayer3_4 = pdb.gimp_drawable_transform_flip_simple(treeLayer3_4, 
	                                             ORIENTATION_HORIZONTAL,   #flip_type 
															       TRUE,   #auto_center 
															          0,   #axis 
															       TRUE)   #clip_result
	
    treeLayer = pdb.gimp_image_merge_down(img, treeLayer3_4, CLIP_TO_IMAGE)
    
    #Recolor inside of the buildings
    recolorLayer = pdb.gimp_layer_new(img, width, height, RGB_IMAGE, "Layer", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(recolorLayer)
    pdb.gimp_image_add_layer(img, recolorLayer, 2)
    pdb.gimp_drawable_fill(recolorLayer, FILL_TRANSPARENT)
    
    pdb.gimp_item_set_visible(starsLayer, FALSE)
    pdb.gimp_fuzzy_select(buildLayer, 450, 660, 5, 2, TRUE, FALSE, 0, TRUE)
    pdb.gimp_context_set_foreground((15, 28, 45))
    pdb.gimp_edit_bucket_fill(recolorLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    
    pdb.gimp_fuzzy_select(buildLayer, 595, 678, 5, 2, TRUE, FALSE, 0, TRUE)
    pdb.gimp_context_set_foreground((15, 28, 45))
    pdb.gimp_edit_bucket_fill(recolorLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    
    pdb.gimp_fuzzy_select(buildLayer, 730, 770, 5, 2, TRUE, FALSE, 0, TRUE)
    pdb.gimp_context_set_foreground((15, 28, 45))
    pdb.gimp_edit_bucket_fill(recolorLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    
    pdb.gimp_fuzzy_select(buildLayer, 950, 640, 5, 2, TRUE, FALSE, 0, TRUE)
    pdb.gimp_context_set_foreground((15, 28, 45))
    pdb.gimp_edit_bucket_fill(recolorLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    
    pdb.gimp_fuzzy_select(buildLayer, 1030, 630, 5, 2, TRUE, FALSE, 0, TRUE)
    pdb.gimp_context_set_foreground((15, 28, 45))
    pdb.gimp_edit_bucket_fill(recolorLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    
    pdb.gimp_fuzzy_select(buildLayer, 1176, 696, 5, 2, TRUE, FALSE, 0, TRUE)
    pdb.gimp_context_set_foreground((15, 28, 45))
    pdb.gimp_edit_bucket_fill(recolorLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    
    pdb.gimp_fuzzy_select(buildLayer, 1395, 774, 5, 2, TRUE, FALSE, 0, TRUE)
    pdb.gimp_context_set_foreground((15, 28, 45))
    pdb.gimp_edit_bucket_fill(recolorLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    
    pdb.gimp_fuzzy_select(buildLayer, 1475, 705, 5, 2, TRUE, FALSE, 0, TRUE)
    pdb.gimp_context_set_foreground((15, 28, 45))
    pdb.gimp_edit_bucket_fill(recolorLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_item_set_visible(starsLayer, TRUE)   
    buildLayer = pdb.gimp_image_merge_down(img, buildLayer, CLIP_TO_IMAGE)
    pdb.gimp_item_set_name(buildLayer, "Buildings")
    pdb.gimp_selection_none(img)
    	
    #Fireworks 1 
    fireworksLayer = pdb.gimp_layer_new(img, width, height, RGB_IMAGE, "Fireworks", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(fireworksLayer)
    pdb.gimp_image_add_layer(img, fireworksLayer, 0)
    pdb.gimp_drawable_fill(fireworksLayer, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground(firewColor1)
    pdb.gimp_context_set_background(firewColor2)
    pdb.plug_in_gflare(img, fireworksLayer, 
                              "Firework 2",    #gflare_name 
                                       250,    #xcenter 
                                       250,    #ycenter 
                                       200,    #radius 
                                         0,    #rotation 
                                         0,    #hue 
                                        60,    #vangle 
                                       400,    #vlength 
                                      TRUE,    #use_asupsample 
                                         3,    #asupsample_max_depth 
                                      0.20)    #asupsample_threshold
    
    #Firework 2
    pdb.plug_in_gflare(img, fireworksLayer, 
                              "Firework 1",    #gflare_name 
                                       700,    #xcenter 
                                       420,    #ycenter 
                                       200,    #radius 
                                         0,    #rotation 
                                         0,    #hue 
                                        60,    #vangle 
                                       400,    #vlength 
                                      TRUE,    #use_asupsample 
                                         3,    #asupsample_max_depth 
                                      0.20)    #asupsample_threshold
    
    #Firework 3
    pdb.plug_in_gflare(img, fireworksLayer, 
                              "Firework 3",    #gflare_name 
                                      1290,    #xcenter 
                                       210,    #ycenter 
                                       200,    #radius 
                                         0,    #rotation 
                                         0,    #hue 
                                        60,    #vangle 
                                       400,    #vlength 
                                      TRUE,    #use_asupsample 
                                         3,    #asupsample_max_depth 
                                      0.20)    #asupsample_threshold

    #Firework 4
    pdb.plug_in_gflare(img, fireworksLayer, 
                              "Firework 4",    #gflare_name 
                                      1700,    #xcenter 
                                       420,    #ycenter 
                                       200,    #radius 
                                         0,    #rotation 
                                         0,    #hue 
                                        60,    #vangle 
                                       400,    #vlength 
                                      TRUE,    #use_asupsample 
                                         3,    #asupsample_max_depth 
                                      0.20)    #asupsample_threshold
    
    pdb.gimp_image_raise_layer_to_top(img, buildLayer)
    
    #Create the New Year number text		
    size = 400
    textW = size/0.4
    textH = size/1
    pdb.gimp_context_set_foreground(fontColor)
    textLayer = pdb.gimp_text_layer_new(img, customtext, "OldSansBlack Medium", size, PIXELS)
    pdb.gimp_image_add_layer(img, textLayer, 0)
    pdb.gimp_layer_add_alpha(textLayer)
    pdb.gimp_text_layer_set_justification(textLayer, 2)
    pdb.gimp_text_layer_set_letter_spacing(textLayer, 10)
    
    #Resize text
    pdb.gimp_layer_scale (textLayer, textW, textH, TRUE)
    
    #Making the text centered	
    textLayer = pdb.gimp_image_get_active_layer(img)
    pdb.gimp_image_set_active_layer(img, textLayer)
    wh = pdb.gimp_drawable_width(textLayer)
    hh = pdb.gimp_drawable_height(textLayer)
    w = pdb.gimp_image_width(img)
    h = pdb.gimp_image_height(img)
    pdb.gimp_image_set_active_layer(img,textLayer)
    centerx=w/2
    centery=h/1.4
    adw=wh/2
    adh=hh/2
    sw=centerx - adw
    sh=centery - adh		
    pdb.gimp_layer_set_offsets(textLayer, sw, sh)
    pdb.gimp_layer_resize_to_image_size(textLayer)
    pdb.gimp_layer_set_mode(textLayer, LAYER_MODE_NORMAL)
    pdb.gimp_layer_set_opacity(textLayer, 0)  
    #Rename the text layer
    pdb.gimp_item_set_name(textLayer, "Text")
    
    #Making the outline text
    outlineLayer = pdb.gimp_layer_new(img, width, height, RGB_IMAGE, "Outline", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(outlineLayer)
    pdb.gimp_image_add_layer(img, outlineLayer, 0)
    pdb.gimp_drawable_fill(outlineLayer, FILL_TRANSPARENT)
    pdb.gimp_image_select_item(img, 2, textLayer)
    pdb.plug_in_sel2path(img, textLayer)
    pdb.gimp_selection_none(img)
    pdb.gimp_context_set_line_width(8)
    pdb.gimp_context_set_line_cap_style(1)
    pdb.gimp_context_set_line_join_style(JOIN_ROUND)
    pdb.gimp_context_set_line_width_unit(PIXELS)
    pdb.gimp_context_set_stroke_method (STROKE_LINE)    
    pdb.gimp_context_set_dynamics("Dynamics Off")  
    pdb.gimp_context_set_paint_method("gimp-paintbrush")
    vectors = pdb.gimp_image_get_vectors_by_name(img, _("Selection"))
    pdb.gimp_drawable_edit_stroke_item(outlineLayer, vectors)
    
    #Bottom lines
    linesLayer = pdb.gimp_layer_new(img, width, height, RGB_IMAGE, "Lines", 100, LAYER_MODE_NORMAL)
    pdb.gimp_layer_add_alpha(linesLayer)
    pdb.gimp_image_add_layer(img, linesLayer, 0)
    pdb.gimp_drawable_fill(linesLayer, FILL_TRANSPARENT)
    pdb.gimp_brushes_set_brush("2. Hardness 100")
    pdb.gimp_context_set_brush_size(8)
    pdb.gimp_context_set_brush_default_hardness()
    pdb.gimp_context_set_brush_spacing(0.01)
    pdb.gimp_context_set_brush_force(0.50)
    pdb.gimp_context_set_foreground(color)
    pdb.gimp_paintbrush_default(linesLayer, 4, [-5, 1085, 621, 1085])
    pdb.gimp_paintbrush_default(linesLayer, 4, [1380, 1085, 2005, 1085])      
	
	#Happy New Year text
    #Create the text		
    size = 250
    text2W = size/0.25
    text2H = size/1.5
    pdb.gimp_context_set_foreground(color)
    textLayer2 = pdb.gimp_text_layer_new(img, customtext2, fontname, size, PIXELS)
    pdb.gimp_image_add_layer(img, textLayer2, 0)
    pdb.gimp_layer_add_alpha(textLayer2)
    pdb.gimp_text_layer_set_justification(textLayer2, 2)
    pdb.gimp_text_layer_set_letter_spacing(textLayer2, 0)
    
    #Resize text
    pdb.gimp_layer_scale (textLayer2, text2W, text2H, TRUE)
    
    #Making the text centered	
    textLayer2 = pdb.gimp_image_get_active_layer(img)
    pdb.gimp_image_set_active_layer(img, textLayer2)
    wh = pdb.gimp_drawable_width(textLayer2)
    hh = pdb.gimp_drawable_height(textLayer2)
    w = pdb.gimp_image_width(img)
    h = pdb.gimp_image_height(img)
    pdb.gimp_image_set_active_layer(img,textLayer2)
    centerx=w/2
    centery=h/1.1
    adw=wh/2
    adh=hh/2
    sw=centerx - adw
    sh=centery - adh		
    pdb.gimp_layer_set_offsets(textLayer2, sw, sh)
    pdb.gimp_layer_resize_to_image_size(textLayer2)
    pdb.gimp_layer_set_mode(textLayer2, LAYER_MODE_NORMAL)
    pdb.gimp_layer_set_opacity(textLayer2, 100)  
    #Rename the text layer
    pdb.gimp_item_set_name(textLayer2, "Text #2")
	
    #Make active the bottom layer and done
    pdb.gimp_image_set_active_layer(img, backLayer)
    #Set the defaults
    pdb.gimp_context_set_defaults()

register(
    "create_a_happy_new_year_design",
    "Create a Happy New Year design",
    "Create a Happy New Year design",
    "Pocholo",
    "Pocholo",
    "2020",
    "Create a Happy New Year design",
    "",
    [
	(PF_STRING, "customtext", "Year", "2022"),
    (PF_STRING, "customtext2", "New Year", "Happy New Year"),
    (PF_FONT, "fontname", "Font face", "Merry Christmas Star"),
    (PF_COLOR, "fontColor", "Match drawing color: Font Color", (239, 170, 77)),
    (PF_COLOR, "color", "Drawing Color", (239, 170, 77)),
    (PF_COLOR, "firewColor1", "Match drawing color: Fireworks Colors 1", (239, 170, 77)),
    (PF_COLOR, "firewColor2", "Match drawing color: Fireworks Colors 2", (246, 141, 0)),
    ],
    [],
    create_a_happy_new_year_design, menu="<Image>/Pocholo-scripts/Create a Happy New Year design",
    domain=("gimp20", gimp.locale_directory))
main()		